//+------------------------------------------------------------------+
//|                                                 MQL5 DLL Samples |
//|                   Copyright 2001-2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#include "stdafx.h"

//---  MQL5       :
//--- _DLLAPI int           fnName(...)    -  cdecl
//--- _DLLAPI int __stdcall fnName(...)    -  stdcall

//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
_DLLAPI int __stdcall fnCalculateSpeed(int &res1,double &res2)
  {
   int    res_int=0;
   double res_double=0.0;
   int    start=GetTickCount();
//---    
   for(int i=0;i<=10000000;i++)
     {
      res_int+=i*i;
      res_int++;
      res_double+=i*i;
      res_double++;
     }
//---   
   res1=res_int;
   res2=res_double;
//---   
   return(GetTickCount()-start);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
_DLLAPI void fnFillArray(int *arr,const int arr_size)
  {
//---   
   if(arr==NULL || arr_size<1) return;
//---  
   for(int i=0;i<arr_size;i++) arr[i]=i;
  }
//+------------------------------------------------------------------+
//|                      |
//| string                 |
//+------------------------------------------------------------------+
_DLLAPI void fnReplaceString(wchar_t *text,wchar_t *from,wchar_t *to)
  {
   wchar_t *cp;
//---  
   if(text==NULL || from==NULL || to==NULL) return;
   if(wcslen(from)!=wcslen(to))             return;
//---  
   if((cp=wcsstr(text,from))==NULL)         return;
//--- 
   memcpy(cp,to,wcslen(to)*sizeof(wchar_t));
  }
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
_DLLAPI void __stdcall fnCrashTest(int *arr)
  {
//---    ,   
   *arr=0;
  }
//+------------------------------------------------------------------+
